## rocsparse 5.7.1

=== CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2022 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

# The ROCm platform requires at least Ubuntu 16.04 or Fedora 24, which have cmake 3.5
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

# Consider removing this in the future
# This should appear before the project command, because it does not use FORCE
if(WIN32)
  set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories")
else()
  set(CMAKE_INSTALL_PREFIX "/opt/rocm" CACHE PATH "Install path prefix, prepended onto install directories")
endif()

# Adding CMAKE_PREFIX_PATH, needed for static builds
list( APPEND CMAKE_PREFIX_PATH /opt/rocm/llvm /opt/rocm )

# CMake modules
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${ROCM_PATH}/lib/cmake/hip /opt/rocm/lib/cmake/hip /opt/rocm/hip/cmake)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Honor per-config flags in try_compile() source-file signature. cmake v3.7 and up
if(POLICY CMP0066)
  cmake_policy(SET CMP0066 NEW)
endif()

# rocSPARSE project
project(rocsparse LANGUAGES CXX Fortran C)

# Determine if CXX Compiler is hip-clang
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  message(STATUS "Using hip-clang to build for amdgpu backend")
else()
  message(FATAL_ERROR "'hipcc' compiler required to compile for ROCm platform.")
endif()

# Build flags
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Build options
option(BUILD_SHARED_LIBS "Build rocSPARSE as a shared library" ON)
option(BUILD_CLIENTS_TESTS "Build tests (requires googletest)" OFF)
option(BUILD_CLIENTS_BENCHMARKS "Build benchmarks" OFF)
option(BUILD_CLIENTS_SAMPLES "Build examples" OFF)
option(BUILD_VERBOSE "Output additional build information" OFF)
option(BUILD_CODE_COVERAGE "Build rocSPARSE with code coverage enabled" OFF)
option(BUILD_ADDRESS_SANITIZER "Build rocSPARSE with address sanitizer enabled" OFF)
option(BUILD_MEMSTAT "Build rocSPARSE with memory statistics enabled" OFF)

#
if(BUILD_CODE_COVERAGE)
  add_compile_options(-fprofile-arcs -ftest-coverage)
  add_link_options(--coverage -lgcov)
endif()

if(BUILD_ADDRESS_SANITIZER)

  # CXX
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -shared-libasan")
  set(CMAKE_CXX_LINK_EXECUTABLE "${CMAKE_CXX_LINK_EXECUTABLE} -fuse-ld=lld")

  # C
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -shared-libasan")
  set(CMAKE_C_LINK_EXECUTABLE "${CMAKE_C_LINK_EXECUTABLE} -fuse-ld=lld")

  # Fortran excluded (see NOTES below)
  # set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fsanitize=address")
  # set(CMAKE_Fortran_LINK_EXECUTABLE "${CMAKE_Fortran_LINK_EXECUTABLE} -fuse-ld=bfd")

  #
  # NOTES ON FORTRAN:
  # Fortran samples can compile with the options above:
  # > -shared-libasan and -fuse-ld=lld is not always recognized from gfortran
  # > -fuse-ld=bfd is here to mimic the required -fuse-ld=lld, but it compiles without too.
  # However, error from asan is popping up from running a Fortran sample:
  # ==14708==AddressSanitizer CHECK failed: /src/external/llvm-project/compiler-rt/lib/asan/../sanitizer_common/sanitizer_common_interceptors.inc:10057 "((__interception::real_memcpy)) != (0)" (0x0, 0x0)
  #
  # !!!!
  # For this reason, and to be consistent with other libraries, Fortran is excluded from the address sanitizer build.
  # !!!!
  #
endif()

# Dependencies
include(cmake/Dependencies.cmake)

# FOR HANDLING ENABLE/DISABLE OPTIONAL BACKWARD COMPATIBILITY for FILE/FOLDER REORG
option(BUILD_FILE_REORG_BACKWARD_COMPATIBILITY "Build with file/folder reorg with backward compatibility enabled" ON)
if(BUILD_FILE_REORG_BACKWARD_COMPATIBILITY AND NOT WIN32)
  rocm_wrap_header_dir(
    ${CMAKE_SOURCE_DIR}/library/include
    PATTERNS "*.h"
    GUARDS SYMLINK WRAPPER
    WRAPPER_LOCATIONS ${CMAKE_INSTALL_INCLUDEDIR}
  )
endif()



# Detect compiler support for target ID
if(CMAKE_CXX_COMPILER MATCHES ".*/hipcc$")
  execute_process(COMMAND ${CMAKE_CXX_COMPILER} "--help"
    OUTPUT_VARIABLE CXX_OUTPUT
    OUTPUT_STRIP_TRAILING_WHITESPACE
    ERROR_STRIP_TRAILING_WHITESPACE)
  string(REGEX MATCH ".mcode\-object\-version" TARGET_ID_SUPPORT ${CXX_OUTPUT})
endif()

# Detect compiler support for target ID
# This section is deprecated. Please use rocm_check_target_ids for future use.
if( CMAKE_CXX_COMPILER MATCHES ".*/hipcc$" )
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} "--help"
        OUTPUT_VARIABLE CXX_OUTPUT
        OUTPUT_STRIP_TRAILING_WHITESPACE
        ERROR_STRIP_TRAILING_WHITESPACE)
    string(REGEX MATCH ".mcode\-object\-version" TARGET_ID_SUPPORT ${CXX_OUTPUT})
endif()

#Set the AMDGPU_TARGETS with backward compatibility
 if(COMMAND rocm_check_target_ids)
    rocm_check_target_ids(DEFAULT_AMDGPU_TARGETS
        TARGETS "gfx803;gfx900:xnack-;gfx906:xnack-;gfx908:xnack-;gfx90a:xnack-;gfx90a:xnack+;gfx940;gfx941;gfx942;gfx1030;gfx1100;gfx1101;gfx1102"
   )
else()
    # Use target ID syntax if supported for AMDGPU_TARGETS
    if(TARGET_ID_SUPPORT)
        set(DEFAULT_AMDGPU_TARGETS "gfx803;gfx900:xnack-;gfx906:xnack-;gfx908:xnack-;gfx1030;gfx1100;gfx1101;gfx1102")
    else()
        set(DEFAULT_AMDGPU_TARGETS "gfx803;gfx900;gfx906;gfx908")
    endif()
endif()

if (AMDGPU_TARGETS)
  set(TMPAMDGPU_TARGETS "${AMDGPU_TARGETS}")
  if(TMPAMDGPU_TARGETS STREQUAL "all" )
    set(AMDGPU_TARGETS "${DEFAULT_AMDGPU_TARGETS}" CACHE STRING "List of specific machine types for library to target" FORCE)
  else()
    set(AMDGPU_TARGETS "${TMPAMDGPU_TARGETS}" CACHE STRING "AMD GPU targets to compile for" FORCE)
  endif()
else()
  set(AMDGPU_TARGETS "${DEFAULT_AMDGPU_TARGETS}" CACHE STRING "List of specific machine types for library to target")
endif()

message(STATUS "AMDGPU_TARGETS: ${AMDGPU_TARGETS}")

# Find rocprim package
find_package(rocprim REQUIRED)

if( CMAKE_CXX_COMPILER_ID MATCHES "Clang" )
  find_package( hip REQUIRED CONFIG PATHS ${HIP_DIR} ${ROCM_PATH} /opt/rocm )
endif( )

# Setup version
set(VERSION_STRING "2.5.4")
rocm_setup_version(VERSION ${VERSION_STRING})
set(rocsparse_SOVERSION 0.1)

if( BUILD_CLIENTS_SAMPLES OR BUILD_CLIENTS_TESTS OR BUILD_CLIENTS_BENCHMARKS )
  set( BUILD_CLIENTS ON )
  if(NOT CLIENTS_OS)
    rocm_set_os_id(CLIENTS_OS)
    string(TOLOWER "${CLIENTS_OS}" CLIENTS_OS)
    rocm_read_os_release(CLIENTS_OS_VERSION VERSION_ID)
  endif()
  find_package(OpenMP QUIET)
  if(OPENMP_FOUND)
    set(OPENMP_RPM "libgomp")
    set(OPENMP_DEB "libomp-dev")
  endif()
  set(GFORTRAN_RPM "libgfortran4")
  set(GFORTRAN_DEB "libgfortran4")
  if(CLIENTS_OS STREQUAL "centos" OR CLIENTS_OS STREQUAL "rhel")
    if(CLIENTS_OS_VERSION VERSION_GREATER_EQUAL "8")
      set(GFORTRAN_RPM "libgfortran")
    endif()
  elseif(CLIENTS_OS STREQUAL "ubuntu" AND CLIENTS_OS_VERSION VERSION_GREATER_EQUAL "20.04")
    set(GFORTRAN_DEB "libgfortran5")
  elseif(CLIENTS_OS STREQUAL "sles" AND OPENMP_FOUND)
    set(OPENMP_RPM "libgomp1")
  endif()

  rocm_package_setup_component(clients)
  rocm_package_setup_client_component(clients-common)
  if( BUILD_CLIENTS_TESTS )
    rocm_package_setup_client_component(
      tests
      DEPENDS
        COMPONENT clients-common
        DEB "${OPENMP_DEB}"
        RPM "${OPENMP_RPM}"
    )
  endif()
  if( BUILD_CLIENTS_BENCHMARKS )
  rocm_package_setup_client_component(
    benchmarks
    DEPENDS
      COMPONENT clients-common
      DEB "${OPENMP_DEB}"
      RPM "${OPENMP_RPM}"
  )
  endif()
  if(BUILD_FORTRAN_CLIENTS)
    rocm_package_add_rpm_dependencies(COMPONENT tests DEPENDS "${GFORTRAN_RPM}")
    rocm_package_add_deb_dependencies(COMPONENT tests DEPENDS "${GFORTRAN_DEB}")
    rocm_package_add_rpm_dependencies(COMPONENT benchmarks DEPENDS "${GFORTRAN_RPM}")
    rocm_package_add_deb_dependencies(COMPONENT benchmarks DEPENDS "${GFORTRAN_DEB}")
  endif()
endif()

# rocSPARSE library
add_subdirectory(library)

# Trigger client builds if selected
if(BUILD_CLIENTS)
  add_subdirectory(clients)
endif()

# Package specific CPACK vars
rocm_package_add_dependencies(DEPENDS "hip-rocclr >= 3.5.0")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md")
set(CPACK_RPM_PACKAGE_LICENSE "MIT")

if(WIN32)
  set(CPACK_SOURCE_GENERATOR "ZIP")
  set(CPACK_GENERATOR "ZIP")
  set(CMAKE_INSTALL_PREFIX "C:/hipSDK" CACHE PATH "Install path" FORCE)
  set(INSTALL_PREFIX "C:/hipSDK")
  set(CPACK_SET_DESTDIR OFF)
  set(CPACK_PACKAGE_INSTALL_DIRECTORY "C:/hipSDK")
  set(CPACK_PACKAGING_INSTALL_PREFIX "")
  set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY OFF)
else()
  if(NOT CPACK_PACKAGING_INSTALL_PREFIX)
    set(CPACK_PACKAGING_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
  endif()
endif()
set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION "\${CPACK_PACKAGING_INSTALL_PREFIX}" )

# Package name
set(package_name rocsparse)

set(ROCSPARSE_CONFIG_DIR "\${CPACK_PACKAGING_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" CACHE PATH "Path placed into ldconfig file")

rocm_create_package(
  NAME ${package_name}
  DESCRIPTION "Radeon Open Compute SPARSE library"
  MAINTAINER "rocSPARSE Maintainer <rocsparse-maintainer@amd.com>"
  LDCONFIG
  LDCONFIG_DIR ${ROCSPARSE_CONFIG_DIR}
)

#
# ADDITIONAL TARGETS FOR CODE COVERAGE
#
if(BUILD_CODE_COVERAGE)
  #
  # > make coverage_cleanup (clean coverage related files.)
  # > make coverage GTEST_FILTER=<>
  # will run:
  #  > make coverage_analysis GTEST_FILTER=<> (analyze tests)
  #  > make coverage_output (generate html documentation)
  #

  #
  # Run coverage analysis
  #
  add_custom_target(coverage_analysis
    COMMAND echo Coverage GTEST_FILTER=\${GTEST_FILTER}
    COMMAND ./clients/staging/rocsparse-test --gtest_filter=\"\${GTEST_FILTER}\"
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

  add_dependencies(coverage_analysis rocsparse)

  #
  # Prepare coverage output
  # This little script is generated because the option '--gcov-tool <program name>' of lcov cannot take arguments.
  #
  add_custom_target(coverage_output
    DEPENDS coverage_analysis
    COMMAND mkdir -p lcoverage
    COMMAND echo "\\#!/bin/bash" > llvm-gcov.sh
    COMMAND echo "\\# THIS FILE HAS BEEN GENERATED" >> llvm-gcov.sh
    COMMAND printf "exec /opt/rocm/llvm/bin/llvm-cov gcov $$\\@" >> llvm-gcov.sh
    COMMAND chmod +x llvm-gcov.sh
    )

  #
  # Generate coverage output.
  #
  add_custom_command(TARGET coverage_output
    COMMAND lcov --directory . --base-directory . --gcov-tool ${CMAKE_BINARY_DIR}/llvm-gcov.sh --capture -o lcoverage/raw_main_coverage.info

=== clients/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2022 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

# The ROCm platform requires Ubuntu 16.04 or Fedora 24, which has cmake 3.5
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

# Consider removing this in the future
# This should appear before the project command, because it does not use FORCE
if(WIN32)
  set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories")
else()
  set(CMAKE_INSTALL_PREFIX "/opt/rocm" CACHE PATH "Install path prefix, prepended onto install directories")
endif()

# This has to be initialized before the project() command appears
# Set the default of CMAKE_BUILD_TYPE to be release, unless user specifies with -D.  MSVC_IDE does not use CMAKE_BUILD_TYPE
if(NOT DEFINED CMAKE_CONFIGURATION_TYPES AND NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel.")
endif()

# This project may compile dependencies for clients
project(rocsparse-clients LANGUAGES CXX)

# Determine if CXX Compiler is hip-clang
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  message(STATUS "Using hip-clang to build for amdgpu backend")
else()
  message(FATAL_ERROR "'hipcc' compiler required to compile for ROCm platform.")
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# This option only works for make/nmake and the ninja generators, but no reason it shouldn't be on all the time
# This tells cmake to create a compile_commands.json file that can be used with clang tooling or vim
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

if(NOT TARGET rocsparse)
  find_package(rocsparse REQUIRED CONFIG PATHS /opt/rocm/rocsparse)

  option(BUILD_CLIENTS_TESTS "Build tests (requires googletest)" OFF)
  option(BUILD_CLIENTS_BENCHMARKS "Build benchmarks" OFF)
  option(BUILD_CLIENTS_SAMPLES "Build examples" ON)
endif()

# HIP headers required of all clients; clients use hip to allocate device memory
list(APPEND CMAKE_PREFIX_PATH /opt/rocm)
find_package(HIP REQUIRED CONFIG PATHS ${CMAKE_PREFIX_PATH})

# Build flags
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# If OpenMP is available, we can use it to speed up some tests
find_package(OpenMP QUIET)

if(OPENMP_FOUND)
  if(NOT TARGET OpenMP::OpenMP_CXX)
    # OpenMP cmake fix for cmake <= 3.9
    add_library(OpenMP::OpenMP_CXX IMPORTED INTERFACE)
    set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_COMPILE_OPTIONS ${OpenMP_CXX_FLAGS})
    set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_LINK_LIBRARIES ${OpenMP_CXX_FLAGS} Threads::Threads)
  endif()
endif()

if(BUILD_CLIENTS_SAMPLES)
  add_subdirectory(samples)
endif()

if(BUILD_CLIENTS_BENCHMARKS)
  add_subdirectory(benchmarks)
endif()

if(BUILD_CLIENTS_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()

set(ROCSPARSE_COMMON "${PROJECT_BINARY_DIR}/staging/rocsparse_common.yaml")
add_custom_command(OUTPUT "${ROCSPARSE_COMMON}"
                   COMMAND ${CMAKE_COMMAND} -E copy include/rocsparse_common.yaml "${ROCSPARSE_COMMON}"
                   DEPENDS include/rocsparse_common.yaml
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

set(ROCSPARSE_TEMPLATE "${PROJECT_BINARY_DIR}/staging/rocsparse_template.yaml")
add_custom_command(OUTPUT "${ROCSPARSE_TEMPLATE}"
                   COMMAND ${CMAKE_COMMAND} -E copy include/rocsparse_template.yaml "${ROCSPARSE_TEMPLATE}"
                   DEPENDS include/rocsparse_template.yaml
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

set(ROCSPARSE_GENTEST "${PROJECT_BINARY_DIR}/staging/rocsparse_gentest.py")
add_custom_command(OUTPUT "${ROCSPARSE_GENTEST}"
                   COMMAND ${CMAKE_COMMAND} -E copy common/rocsparse_gentest.py "${ROCSPARSE_GENTEST}"
                   DEPENDS common/rocsparse_gentest.py
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

add_custom_target(rocsparse-common DEPENDS "${ROCSPARSE_COMMON}" "${ROCSPARSE_TEMPLATE}" "${ROCSPARSE_GENTEST}")

rocm_install(
  FILES "${ROCSPARSE_COMMON}" "${ROCSPARSE_TEMPLATE}"
  COMPONENT clients-common
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)
rocm_install(
  PROGRAMS "${ROCSPARSE_GENTEST}"
  COMPONENT clients-common
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== clients/benchmarks/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2023 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

find_package(rocsparseio QUIET)

# MEMSTAT ?
if(BUILD_MEMSTAT)
  add_compile_options(-DROCSPARSE_WITH_MEMSTAT)
endif()

set(ROCSPARSE_BENCHMARK_SOURCES
  client.cpp
  rocsparse_bench_app.cpp
  rocsparse_arguments_config.cpp
  rocsparse_bench.cpp
  rocsparse_bench_cmdlines.cpp
  rocsparse_routine.cpp
)

set(ROCSPARSE_CLIENTS_COMMON
  ../common/utility.cpp
  ../common/rocsparse_check.cpp
  ../common/rocsparse_enum.cpp
  ../common/rocsparse_init.cpp
  ../common/rocsparse_host.cpp
  ../common/rocsparse_matrix_factory.cpp
  ../common/rocsparse_matrix_factory_laplace2d.cpp
  ../common/rocsparse_matrix_factory_laplace3d.cpp
  ../common/rocsparse_matrix_factory_zero.cpp
  ../common/rocsparse_matrix_factory_random.cpp
  ../common/rocsparse_matrix_factory_tridiagonal.cpp
  ../common/rocsparse_matrix_factory_pentadiagonal.cpp
  ../common/rocsparse_matrix_factory_file.cpp
  ../common/rocsparse_exporter_rocsparseio.cpp
  ../common/rocsparse_exporter_rocalution.cpp
  ../common/rocsparse_exporter_matrixmarket.cpp
  ../common/rocsparse_exporter_ascii.cpp
  ../common/rocsparse_importer.cpp
  ../common/rocsparse_importer_rocalution.cpp
  ../common/rocsparse_importer_rocsparseio.cpp
  ../common/rocsparse_importer_matrixmarket.cpp
  ../common/rocsparse_clients_envariables.cpp
)


set(ROCSPARSE_CLIENTS_TESTINGS
../testings/testing_axpyi.cpp
../testings/testing_doti.cpp
../testings/testing_dotci.cpp
../testings/testing_gthr.cpp
../testings/testing_gthrz.cpp
../testings/testing_roti.cpp
../testings/testing_sctr.cpp
../testings/testing_bsrmv.cpp
../testings/testing_bsrxmv.cpp
../testings/testing_bsrsv.cpp
../testings/testing_coomv.cpp
../testings/testing_csrmv.cpp
../testings/testing_csrmv_managed.cpp
../testings/testing_csrsv.cpp
../testings/testing_csritsv.cpp
../testings/testing_ellmv.cpp
../testings/testing_hybmv.cpp
../testings/testing_gebsrmv.cpp
../testings/testing_bsrmm.cpp
../testings/testing_gebsrmm.cpp
../testings/testing_csrmm.cpp
../testings/testing_spmm_csr.cpp
../testings/testing_spmm_csc.cpp
../testings/testing_spmm_coo.cpp
../testings/testing_spmm_bell.cpp
../testings/testing_spmm_batched_csr.cpp
../testings/testing_spmm_batched_csc.cpp
../testings/testing_spmm_batched_coo.cpp
../testings/testing_spmm_batched_bell.cpp
../testings/testing_csrsm.cpp
../testings/testing_bsrsm.cpp
../testings/testing_gemmi.cpp
../testings/testing_bsrgemm.cpp
../testings/testing_bsrgeam.cpp
../testings/testing_csrgeam.cpp
../testings/testing_csrgemm.cpp
../testings/testing_csrgemm_reuse.cpp
../testings/testing_bsric0.cpp
../testings/testing_bsrilu0.cpp
../testings/testing_csric0.cpp
../testings/testing_csrilu0.cpp
../testings/testing_csritilu0.cpp
../testings/testing_gpsv_interleaved_batch.cpp
../testings/testing_gtsv.cpp
../testings/testing_gtsv_no_pivot.cpp
../testings/testing_gtsv_no_pivot_strided_batch.cpp
../testings/testing_gtsv_interleaved_batch.cpp
../testings/testing_csr2coo.cpp
../testings/testing_csr2csc.cpp
../testings/testing_gebsr2gebsc.cpp
../testings/testing_gebsr2gebsr.cpp
../testings/testing_csr2ell.cpp
../testings/testing_csr2hyb.cpp
../testings/testing_csr2bsr.cpp
../testings/testing_csr2gebsr.cpp
../testings/testing_coo2csr.cpp
../testings/testing_ell2csr.cpp
../testings/testing_hyb2csr.cpp
../testings/testing_bsr2csr.cpp
../testings/testing_gebsr2csr.cpp
../testings/testing_csr2csr_compress.cpp
../testings/testing_prune_csr2csr.cpp
../testings/testing_prune_csr2csr_by_percentage.cpp
../testings/testing_identity.cpp
../testings/testing_csrsort.cpp
../testings/testing_cscsort.cpp
../testings/testing_coosort.cpp
../testings/testing_csricsv.cpp
../testings/testing_csrilusv.cpp
../testings/testing_nnz.cpp
../testings/testing_dense2csr.cpp
../testings/testing_dense2coo.cpp
../testings/testing_prune_dense2csr.cpp
../testings/testing_prune_dense2csr_by_percentage.cpp
../testings/testing_dense2csc.cpp
../testings/testing_csr2dense.cpp
../testings/testing_csc2dense.cpp
../testings/testing_coo2dense.cpp
../testings/testing_spmv_bsr.cpp
../testings/testing_spmv_coo.cpp
../testings/testing_spmv_coo_aos.cpp
../testings/testing_spmv_csr.cpp
../testings/testing_spmv_csc.cpp
../testings/testing_spmv_ell.cpp
../testings/testing_spsv_csr.cpp
../testings/testing_spsv_coo.cpp
../testings/testing_spitsv_csr.cpp
../testings/testing_spsm_csr.cpp
../testings/testing_spsm_coo.cpp
../testings/testing_sparse_to_dense_coo.cpp
../testings/testing_sparse_to_dense_csr.cpp
../testings/testing_sparse_to_dense_csc.cpp
../testings/testing_dense_to_sparse_coo.cpp
../testings/testing_dense_to_sparse_csr.cpp
../testings/testing_dense_to_sparse_csc.cpp
../testings/testing_spgemm_bsr.cpp
../testings/testing_spgemm_csr.cpp
../testings/testing_gemvi.cpp
../testings/testing_sddmm.cpp
../testings/testing_csrcolor.cpp
../testings/testing_check_matrix_csr.cpp
../testings/testing_check_matrix_csc.cpp
../testings/testing_check_matrix_coo.cpp
../testings/testing_check_matrix_gebsr.cpp
../testings/testing_check_matrix_gebsc.cpp
../testings/testing_check_matrix_ell.cpp
../testings/testing_check_matrix_hyb.cpp
../testings/testing_bsrpad_value.cpp
)

add_executable(rocsparse-bench ${ROCSPARSE_BENCHMARK_SOURCES} ${ROCSPARSE_CLIENTS_COMMON} ${ROCSPARSE_CLIENTS_TESTINGS})

# Target compile options
target_compile_options(rocsparse-bench PRIVATE -Wno-unused-command-line-argument -Wall)
if (rocsparseio_FOUND)
  message("Compile with ROCSPARSEIO")
  target_compile_options(rocsparse-bench PRIVATE -DROCSPARSEIO)
endif()

# Internal common header
target_include_directories(rocsparse-bench PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

# Target link libraries
target_link_libraries(rocsparse-bench PRIVATE roc::rocsparse hip::host hip::device)
if (rocsparseio_FOUND)
  target_link_libraries(rocsparse-bench PRIVATE roc::rocsparseio)
endif()

# Add OpenMP if available
if(OPENMP_FOUND)
if (NOT WIN32)
   target_link_libraries(rocsparse-bench PRIVATE OpenMP::OpenMP_CXX -Wl,-rpath=${HIP_CLANG_ROOT}/lib)
  else()
   target_link_libraries(rocsparse-bench PRIVATE libomp)
  endif()
endif()

# Set benchmark output directory
set_target_properties(rocsparse-bench PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging")

rocm_install(TARGETS rocsparse-bench COMPONENT benchmarks)

=== clients/samples/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2022 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

# Function to add rocsparse examples
function(add_rocsparse_example EXAMPLE_SOURCE)
  get_filename_component(EXAMPLE_TARGET ${EXAMPLE_SOURCE} NAME_WE)
  add_executable(${EXAMPLE_TARGET} ${EXAMPLE_SOURCE})

  # Target compile options
  target_compile_options(${EXAMPLE_TARGET} PRIVATE -Wno-unused-command-line-argument)

  # Include common client headers
  target_include_directories(${EXAMPLE_TARGET} PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

  # Linker dependencies
  target_link_libraries(${EXAMPLE_TARGET} PRIVATE roc::rocsparse hip::host hip::device)
  # Target properties
  set_target_properties(${EXAMPLE_TARGET} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging")
endfunction()

# Examples

# Empty C program for checking rocsparse headers are C compatible.
# Post-poned, weird compiler flags on Windows.
# add_rocsparse_example(example_c_headers.c)

# Auxiliary
add_rocsparse_example(example_handle.cpp)

# Level 1
add_rocsparse_example(example_axpyi.cpp)
add_rocsparse_example(example_doti.cpp)
add_rocsparse_example(example_dotci.cpp)
add_rocsparse_example(example_gthr.cpp)
add_rocsparse_example(example_gthrz.cpp)
add_rocsparse_example(example_roti.cpp)
add_rocsparse_example(example_sctr.cpp)

# Level 2
add_rocsparse_example(example_bsrmv.cpp)
add_rocsparse_example(example_bsrsv.cpp)
add_rocsparse_example(example_coomv.cpp)
add_rocsparse_example(example_csrmv.cpp)
add_rocsparse_example(example_ellmv.cpp)
add_rocsparse_example(example_hybmv.cpp)
add_rocsparse_example(example_csrsv.cpp)
add_rocsparse_example(example_csritsv.cpp)
add_rocsparse_example(example_spmv_coo.cpp)
add_rocsparse_example(example_spmv_csr.cpp)
add_rocsparse_example(example_spmv_ell.cpp)
add_rocsparse_example(example_gebsrmv.cpp)
add_rocsparse_example(example_gemvi.cpp)

# Level 3
add_rocsparse_example(example_bsrmm.cpp)
add_rocsparse_example(example_csrmm.cpp)
add_rocsparse_example(example_spmm_csr.cpp)
add_rocsparse_example(example_spmm_coo.cpp)
add_rocsparse_example(example_spmm_batched_csr.cpp)
add_rocsparse_example(example_spmm_batched_coo.cpp)
add_rocsparse_example(example_bsrsm.cpp)
add_rocsparse_example(example_csrsm.cpp)
add_rocsparse_example(example_gemmi.cpp)
add_rocsparse_example(example_gtsv.cpp)

# Precond
add_rocsparse_example(example_gpsv.cpp)

# Extra
add_rocsparse_example(example_csrgeam.cpp)
add_rocsparse_example(example_csrgemm.cpp)
add_rocsparse_example(example_spgemm.cpp)

# Managed
add_rocsparse_example(example_csrmv_managed.cpp)
add_rocsparse_example(example_csrsv_managed.cpp)

# Fortran examples
if(TARGET rocsparse)
  # Compile Fortran examples only if built directly with package
  # else the Fortran module file is not generated

  # BUILD_ADDRESS_SANITIZER EXCLUDED, SEE NOTES IN THE ROOT CMakeLists.txt.
  if (NOT WIN32 AND NOT BUILD_ADDRESS_SANITIZER)

    function(add_rocsparse_fortran_example EXAMPLE_SOURCE)
      get_filename_component(EXAMPLE_TARGET ${EXAMPLE_SOURCE} NAME_WE)
      add_executable(${EXAMPLE_TARGET} ${EXAMPLE_SOURCE})

      # Target compile options
      target_compile_options(${EXAMPLE_TARGET} PRIVATE -Wno-unused-command-line-argument)

      # Include common client headers
      target_include_directories(${EXAMPLE_TARGET} PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

      # Linker dependencies
      target_link_libraries(${EXAMPLE_TARGET} PRIVATE roc::rocsparse hip::host)
      if (BUILD_CODE_COVERAGE)
	target_link_libraries(${EXAMPLE_TARGET} PRIVATE -lgcov)
      endif()

      # Target properties
      set_target_properties(${EXAMPLE_TARGET} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging")
    endfunction()

    add_rocsparse_fortran_example(example_fortran_gtsv.f90)
    add_rocsparse_fortran_example(example_fortran_csric0.f90)
    add_rocsparse_fortran_example(example_fortran_csrilu0.f90)
    add_rocsparse_fortran_example(example_fortran_bsrmm.f90)
    add_rocsparse_fortran_example(example_fortran_bsric0.f90)
    add_rocsparse_fortran_example(example_fortran_bsrilu0.f90)
    add_rocsparse_fortran_example(example_fortran_bsrsv.f90)
    add_rocsparse_fortran_example(example_fortran_csrsv.f90)
    add_rocsparse_fortran_example(example_fortran_spmv.f90)
    add_rocsparse_fortran_example(example_fortran_csrsm.f90)
    add_rocsparse_fortran_example(example_fortran_gemmi.f90)
    add_rocsparse_fortran_example(example_fortran_auxiliary.f90)
    add_rocsparse_fortran_example(example_fortran_dotci.f90)
    add_rocsparse_fortran_example(example_fortran_roti.f90)
  endif()
endif()

=== clients/tests/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2022 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

find_package(GTest 1.11.0 REQUIRED)
find_package(rocsparseio QUIET)

# MEMSTAT ?
if(BUILD_MEMSTAT)
  add_compile_options(-DROCSPARSE_WITH_MEMSTAT)
endif()

#
# Client matrices.
#
if(NOT EXISTS "${CMAKE_MATRICES_DIR}")
  #
  # Download.
  #
  set(CMAKE_MATRICES_DIR ${PROJECT_BINARY_DIR}/matrices CACHE STRING "Matrices directory.")
  file(MAKE_DIRECTORY ${CMAKE_MATRICES_DIR})

  if(NOT TARGET rocsparse)
    set(CONVERT_SOURCE ${CMAKE_SOURCE_DIR}/../deps/convert.cpp CACHE STRING "Convert tool mtx2csr.")
    include(${CMAKE_SOURCE_DIR}/../cmake/ClientMatrices.cmake)
  else()
   set(CONVERT_SOURCE ${CMAKE_SOURCE_DIR}/deps/convert.cpp CACHE STRING "Convert tool mtx2csr.")
    include(${CMAKE_SOURCE_DIR}/cmake/ClientMatrices.cmake)
  endif()

else()
  #
  # Copy.
  #
  if(NOT CMAKE_MATRICES_DIR STREQUAL "${PROJECT_BINARY_DIR}/matrices")
    message("Copy matrix files from ${CMAKE_MATRICES_DIR} to ${PROJECT_BINARY_DIR}/matrices")

    execute_process(COMMAND cp -r ${CMAKE_MATRICES_DIR} ${PROJECT_BINARY_DIR}/matrices RESULT_VARIABLE STATUS WORKING_DIRECTORY ${CMAKE_MATRICES_DIR})

    if(STATUS AND NOT STATUS EQUAL 0)
      message(FATAL_ERROR "Failed to copy matrix .csr files, aborting.")
    endif()
  endif()

endif()

set(ROCSPARSE_TEST_SOURCES
  test_axpby.cpp
  test_axpyi.cpp
  test_doti.cpp
  test_dotci.cpp
  test_gather.cpp
  test_scatter.cpp
  test_gthr.cpp
  test_gthrz.cpp
  test_rot.cpp
  test_roti.cpp
  test_sctr.cpp
  test_bsrmv.cpp
  test_bsrxmv.cpp
  test_bsrsv.cpp
  test_coomv.cpp
  test_csrmv.cpp
  test_csrmv_managed.cpp
  test_csrsv.cpp
  test_csritsv.cpp
  test_ellmv.cpp
  test_hybmv.cpp
  test_gebsrmv.cpp
  test_bsrmm.cpp
  test_gebsrmm.cpp
  test_csrmm.cpp
  test_csrsm.cpp
  test_bsrsm.cpp
  test_gemmi.cpp
  test_bsrgeam.cpp
  test_bsrgemm.cpp
  test_csrgeam.cpp
  test_csrgemm.cpp
  test_csrgemm_reuse.cpp
  test_bsric0.cpp
  test_bsrilu0.cpp
  test_csric0.cpp
  test_csrilu0.cpp
  test_csritilu0.cpp
  test_gtsv_no_pivot.cpp
  test_gtsv_no_pivot_strided_batch.cpp
  test_gtsv_interleaved_batch.cpp
  test_gpsv_interleaved_batch.cpp
  test_csr2coo.cpp
  test_csr2csc.cpp
  test_gebsr2gebsc.cpp
  test_csr2ell.cpp
  test_csr2hyb.cpp
  test_csr2bsr.cpp
  test_csr2gebsr.cpp
  test_coo2csr.cpp
  test_ell2csr.cpp
  test_hyb2csr.cpp
  test_bsr2csr.cpp
  test_gebsr2csr.cpp
  test_gebsr2gebsr.cpp
  test_csr2csr_compress.cpp
  test_prune_csr2csr.cpp
  test_prune_csr2csr_by_percentage.cpp
  test_identity.cpp
  test_csrsort.cpp
  test_cscsort.cpp
  test_coosort.cpp
  test_csricsv.cpp
  test_csrilusv.cpp
  test_nnz.cpp
  test_dense2csr.cpp
  test_dense2coo.cpp
  test_prune_dense2csr.cpp
  test_prune_dense2csr_by_percentage.cpp
  test_dense2csc.cpp
  test_csr2dense.cpp
  test_csc2dense.cpp
  test_coo2dense.cpp
  test_spvec_descr.cpp
  test_spmat_descr.cpp
  test_dnvec_descr.cpp
  test_dnmat_descr.cpp
  test_spmv_bsr.cpp
  test_spmv_coo.cpp
  test_spmv_coo_aos.cpp
  test_spmv_csr.cpp
  test_spmv_csc.cpp
  test_spmv_ell.cpp
  test_spsv_csr.cpp
  test_spitsv_csr.cpp
  test_spsv_coo.cpp
  test_spsm_csr.cpp
  test_spsm_coo.cpp
  test_spmm_csr.cpp
  test_spmm_csc.cpp
  test_spmm_coo.cpp
  test_spmm_bell.cpp
  test_spmm_batched_csr.cpp
  test_spmm_batched_csc.cpp
  test_spmm_batched_coo.cpp
  test_spmm_batched_bell.cpp
  test_spvv.cpp
  test_sparse_to_dense_coo.cpp
  test_sparse_to_dense_csr.cpp
  test_sparse_to_dense_csc.cpp
  test_dense_to_sparse_coo.cpp
  test_dense_to_sparse_csr.cpp
  test_dense_to_sparse_csc.cpp
  test_spgemm_bsr.cpp
  test_spgemm_csr.cpp
  test_gtsv.cpp
  test_gemvi.cpp
  test_sddmm.cpp
  test_csrcolor.cpp
  test_copy_info.cpp
  test_check_matrix_csr.cpp
  test_check_matrix_coo.cpp
  test_check_matrix_gebsr.cpp
  test_check_matrix_gebsc.cpp
  test_check_matrix_csc.cpp
  test_check_matrix_ell.cpp
  test_check_matrix_hyb.cpp
  test_bsrpad_value.cpp
)

set(ROCSPARSE_CLIENTS_TESTINGS
../testings/testing_axpby.cpp
../testings/testing_axpyi.cpp
../testings/testing_doti.cpp
../testings/testing_dotci.cpp
../testings/testing_gather.cpp
../testings/testing_scatter.cpp
../testings/testing_gthr.cpp
../testings/testing_gthrz.cpp
../testings/testing_rot.cpp
../testings/testing_roti.cpp
../testings/testing_sctr.cpp
../testings/testing_bsrmv.cpp
../testings/testing_bsrxmv.cpp
../testings/testing_bsrsv.cpp
../testings/testing_coomv.cpp
../testings/testing_csrmv.cpp
../testings/testing_csrmv_managed.cpp
../testings/testing_csrsv.cpp
../testings/testing_csritsv.cpp
../testings/testing_ellmv.cpp
../testings/testing_hybmv.cpp
../testings/testing_gebsrmv.cpp
../testings/testing_bsrmm.cpp
../testings/testing_gebsrmm.cpp
../testings/testing_csrmm.cpp
../testings/testing_csrsm.cpp
../testings/testing_bsrsm.cpp
../testings/testing_gemmi.cpp
../testings/testing_bsrgeam.cpp
../testings/testing_bsrgemm.cpp
../testings/testing_csrgeam.cpp
../testings/testing_csrgemm.cpp
../testings/testing_csrgemm_reuse.cpp
../testings/testing_bsric0.cpp
../testings/testing_bsrilu0.cpp
../testings/testing_csric0.cpp
../testings/testing_csrilu0.cpp
../testings/testing_csritilu0.cpp
../testings/testing_gtsv_no_pivot.cpp
../testings/testing_gtsv_no_pivot_strided_batch.cpp
../testings/testing_gtsv_interleaved_batch.cpp
../testings/testing_gpsv_interleaved_batch.cpp
../testings/testing_csr2coo.cpp
../testings/testing_csr2csc.cpp
../testings/testing_gebsr2gebsc.cpp
../testings/testing_gebsr2gebsr.cpp
../testings/testing_csr2ell.cpp
../testings/testing_csr2hyb.cpp
../testings/testing_csr2bsr.cpp
../testings/testing_csr2gebsr.cpp
../testings/testing_coo2csr.cpp
../testings/testing_ell2csr.cpp
../testings/testing_hyb2csr.cpp
../testings/testing_bsr2csr.cpp
../testings/testing_gebsr2csr.cpp
../testings/testing_csr2csr_compress.cpp
../testings/testing_prune_csr2csr.cpp
../testings/testing_prune_csr2csr_by_percentage.cpp
../testings/testing_identity.cpp
../testings/testing_csrsort.cpp
../testings/testing_cscsort.cpp
../testings/testing_coosort.cpp
../testings/testing_csricsv.cpp
../testings/testing_csrilusv.cpp
../testings/testing_nnz.cpp
../testings/testing_dense2csr.cpp
../testings/testing_dense2coo.cpp
../testings/testing_prune_dense2csr.cpp
../testings/testing_prune_dense2csr_by_percentage.cpp
../testings/testing_dense2csc.cpp
../testings/testing_csr2dense.cpp
../testings/testing_csc2dense.cpp
../testings/testing_coo2dense.cpp
../testings/testing_spvec_descr.cpp
../testings/testing_spmat_descr.cpp
../testings/testing_dnvec_descr.cpp
../testings/testing_dnmat_descr.cpp
../testings/testing_spmv_coo.cpp
../testings/testing_spmv_coo_aos.cpp
../testings/testing_spmv_bsr.cpp
../testings/testing_spmv_csr.cpp
../testings/testing_spmv_csc.cpp
../testings/testing_spmv_ell.cpp
../testings/testing_spsv_csr.cpp
../testings/testing_spitsv_csr.cpp
../testings/testing_spsv_coo.cpp
../testings/testing_spsm_csr.cpp
../testings/testing_spsm_coo.cpp
../testings/testing_spmm_csr.cpp
../testings/testing_spmm_csc.cpp
../testings/testing_spmm_coo.cpp
../testings/testing_spmm_bell.cpp
../testings/testing_spmm_batched_csr.cpp
../testings/testing_spmm_batched_csc.cpp
../testings/testing_spmm_batched_coo.cpp
../testings/testing_spmm_batched_bell.cpp
../testings/testing_spvv.cpp
../testings/testing_sparse_to_dense_coo.cpp
../testings/testing_sparse_to_dense_csr.cpp
../testings/testing_sparse_to_dense_csc.cpp
../testings/testing_dense_to_sparse_coo.cpp
../testings/testing_dense_to_sparse_csr.cpp
../testings/testing_dense_to_sparse_csc.cpp
../testings/testing_spgemm_bsr.cpp
../testings/testing_spgemm_csr.cpp
../testings/testing_gtsv.cpp
../testings/testing_gemvi.cpp
../testings/testing_sddmm.cpp
../testings/testing_csrcolor.cpp
../testings/testing_copy_info.cpp
../testings/testing_check_matrix_csr.cpp
../testings/testing_check_matrix_coo.cpp
../testings/testing_check_matrix_gebsr.cpp
../testings/testing_check_matrix_gebsc.cpp
../testings/testing_check_matrix_csc.cpp
../testings/testing_check_matrix_ell.cpp
../testings/testing_check_matrix_hyb.cpp
../testings/testing_bsrpad_value.cpp
  )


set(ROCSPARSE_CLIENTS_COMMON
  ../common/utility.cpp
  ../common/rocsparse_check.cpp
  ../common/rocsparse_parse_data.cpp
  ../common/rocsparse_enum.cpp
  ../common/rocsparse_init.cpp
  ../common/rocsparse_host.cpp
  ../common/rocsparse_matrix_factory.cpp
  ../common/rocsparse_matrix_factory_laplace2d.cpp
  ../common/rocsparse_matrix_factory_laplace3d.cpp
  ../common/rocsparse_matrix_factory_zero.cpp
  ../common/rocsparse_matrix_factory_random.cpp
  ../common/rocsparse_matrix_factory_tridiagonal.cpp
  ../common/rocsparse_matrix_factory_pentadiagonal.cpp
  ../common/rocsparse_matrix_factory_file.cpp
  ../common/rocsparse_exporter_rocsparseio.cpp
  ../common/rocsparse_exporter_rocalution.cpp
  ../common/rocsparse_exporter_matrixmarket.cpp
  ../common/rocsparse_exporter_ascii.cpp
  ../common/rocsparse_importer.cpp
  ../common/rocsparse_importer_rocalution.cpp
  ../common/rocsparse_importer_rocsparseio.cpp
  ../common/rocsparse_importer_matrixmarket.cpp
  ../common/rocsparse_clients_envariables.cpp
  )

add_executable(rocsparse-test rocsparse_test_main.cpp ${ROCSPARSE_TEST_SOURCES} ${ROCSPARSE_CLIENTS_COMMON} ${ROCSPARSE_CLIENTS_TESTINGS})

# Set GOOGLE_TEST definition
target_compile_definitions(rocsparse-test PRIVATE GOOGLE_TEST)

# Target compile options
target_compile_options(rocsparse-test PRIVATE -ffp-contract=on -mfma -Wno-unused-command-line-argument -Wall)
if (rocsparseio_FOUND)
  message("Compiles rocSPARSE client with rocSPARSEIO to import/export matrices.")
  target_compile_options(rocsparse-test PRIVATE -DROCSPARSEIO)
endif()

# Internal common header
target_include_directories(rocsparse-test PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

# Target link libraries
target_link_libraries(rocsparse-test PRIVATE GTest::GTest roc::rocsparse hip::host hip::device)
if (rocsparseio_FOUND)
  target_link_libraries(rocsparse-test PRIVATE roc::rocsparseio)
endif()

# Add OpenMP if available
if(OPENMP_FOUND)
if (NOT WIN32)
   target_link_libraries(rocsparse-test PRIVATE OpenMP::OpenMP_CXX -Wl,-rpath=${HIP_CLANG_ROOT}/lib)
  else()
   target_link_libraries(rocsparse-test PRIVATE libomp)
  endif()
endif()


# Set test output directory
set_target_properties(rocsparse-test PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging")

rocm_install(TARGETS rocsparse-test COMPONENT tests)

string(REGEX REPLACE ".cpp" ".yaml" ROCSPARSE_TEST_YAMLS "${ROCSPARSE_TEST_SOURCES}")

# Prepare testing data
set(ROCSPARSE_TEST_DATA "${PROJECT_BINARY_DIR}/staging/rocsparse_test.data")
add_custom_command(OUTPUT "${ROCSPARSE_TEST_DATA}"
                   COMMAND ${python} ../common/rocsparse_gentest.py -I ../include rocsparse_test.yaml -o "${ROCSPARSE_TEST_DATA}"

=== docs/source/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = rocSPARSE
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/source/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.8
# by the following command:
#
#    pip-compile docs/source/requirements.in
#
alabaster==0.7.12
    # via sphinx
asttokens==2.2.0
    # via stack-data
attrs==22.1.0
    # via
    #   jsonschema
    #   jupyter-cache
babel==2.10.3
    # via sphinx
backcall==0.2.0
    # via ipython
beautifulsoup4==4.11.1
    # via pydata-sphinx-theme
breathe==4.31.0
    # via -r docs/source/requirements.in
certifi==2022.12.7
    # via requests
charset-normalizer==2.1.0
    # via requests
click==8.1.3
    # via
    #   jupyter-cache
    #   sphinx-external-toc
debugpy==1.6.4
    # via ipykernel
decorator==5.1.1
    # via ipython
docutils==0.16
    # via
    #   -r docs/source/requirements.in
    #   breathe
    #   myst-parser
    #   pydata-sphinx-theme
    #   sphinx
entrypoints==0.4
    # via jupyter-client
executing==1.2.0
    # via stack-data
fastjsonschema==2.16.2
    # via nbformat
greenlet==2.0.1
    # via sqlalchemy
idna==3.3
    # via requests
imagesize==1.4.1
    # via sphinx
importlib-metadata==5.1.0
    # via
    #   jupyter-cache
    #   myst-nb
importlib-resources==5.10.0
    # via jsonschema
ipykernel==6.17.1
    # via myst-nb
ipython==8.7.0
    # via
    #   ipykernel
    #   myst-nb
jedi==0.18.2
    # via ipython
jinja2==3.1.2
    # via
    #   myst-parser
    #   sphinx
jsonschema==4.17.3
    # via nbformat
jupyter-cache==0.5.0
    # via myst-nb
jupyter-client==7.4.7
    # via
    #   ipykernel
    #   nbclient
jupyter-core==5.1.0
    # via
    #   jupyter-client
    #   nbformat
linkify-it-py==1.0.3
    # via myst-parser
markdown-it-py==2.1.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.1
    # via jinja2
matplotlib-inline==0.1.6
    # via
    #   ipykernel
    #   ipython
mdit-py-plugins==0.3.1
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-nb==0.17.1
    # via -r docs/source/requirements.in
myst-parser[linkify]==0.18.1
    # via
    #   -r docs/source/requirements.in
    #   myst-nb
nbclient==0.5.13
    # via
    #   jupyter-cache
    #   myst-nb
nbformat==5.7.0
    # via
    #   jupyter-cache
    #   myst-nb
    #   nbclient
nest-asyncio==1.5.6
    # via
    #   ipykernel
    #   jupyter-client
    #   nbclient
packaging==21.3
    # via
    #   ipykernel
    #   pydata-sphinx-theme
    #   sphinx
parso==0.8.3
    # via jedi
pexpect==4.8.0
    # via ipython
pickleshare==0.7.5
    # via ipython
pkgutil-resolve-name==1.3.10
    # via jsonschema
platformdirs==2.5.4
    # via jupyter-core
prompt-toolkit==3.0.33
    # via ipython
psutil==5.9.4
    # via ipykernel
ptyprocess==0.7.0
    # via pexpect
pure-eval==0.2.2
    # via stack-data
pydata-sphinx-theme==0.8.1
    # via sphinx-book-theme
pygments==2.12.0
    # via
    #   ipython
    #   sphinx
pyparsing==3.0.9
    # via packaging
pyrsistent==0.19.2
    # via jsonschema
python-dateutil==2.8.2
    # via jupyter-client
pytz==2022.1
    # via babel
pyyaml==6.0
    # via
    #   jupyter-cache
    #   myst-nb
    #   myst-parser
    #   sphinx-book-theme
    #   sphinx-external-toc
pyzmq==24.0.1
    # via
    #   ipykernel
    #   jupyter-client
requests==2.28.1
    # via sphinx
six==1.16.0
    # via
    #   asttokens
    #   python-dateutil
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.3.2.post1
    # via beautifulsoup4
sphinx==4.3.1
    # via
    #   -r docs/source/requirements.in
    #   breathe
    #   myst-nb
    #   myst-parser
    #   pydata-sphinx-theme
    #   sphinx-book-theme
    #   sphinx-copybutton
    #   sphinx-design
    #   sphinx-external-toc
sphinx-book-theme==0.3.3
    # via -r docs/source/requirements.in
sphinx-copybutton==0.5.1
    # via -r docs/source/requirements.in
sphinx-design==0.3.0
    # via -r docs/source/requirements.in
sphinx-external-toc==0.3.1
    # via -r docs/source/requirements.in
sphinxcontrib-applehelp==1.0.2
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.0
    # via sphinx
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
sqlalchemy==1.4.44
    # via jupyter-cache
stack-data==0.6.2
    # via ipython
tabulate==0.9.0
    # via jupyter-cache
tornado==6.2
    # via
    #   ipykernel
    #   jupyter-client
traitlets==5.6.0
    # via
    #   ipykernel
    #   ipython
    #   jupyter-client
    #   jupyter-core
    #   matplotlib-inline
    #   nbclient
    #   nbformat
typing-extensions==4.4.0
    # via
    #   myst-nb
    #   myst-parser
uc-micro-py==1.0.1
    # via linkify-it-py
urllib3==1.26.11
    # via requests
wcwidth==0.2.5
    # via prompt-toolkit
zipp==3.11.0
    # via
    #   importlib-metadata
    #   importlib-resources

# The following packages are considered to be unsafe in a requirements file:
# setuptools

=== library/src/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2020-2022 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

# rocSPARSE Fortran source
if (NOT WIN32)
set(rocsparse_fortran_source
  src/rocsparse_enums.f90
  src/rocsparse.f90
)
endif()

# rocSPARSE source
set(rocsparse_source
  src/handle.cpp
  src/status.cpp
  src/rocsparse_auxiliary.cpp
  src/rocsparse_envariables.cpp
  src/rocsparse_memstat.cpp

# Level1
  src/level1/rocsparse_axpyi.cpp
  src/level1/rocsparse_doti.cpp
  src/level1/rocsparse_dotci.cpp
  src/level1/rocsparse_gthr.cpp
  src/level1/rocsparse_gthrz.cpp
  src/level1/rocsparse_roti.cpp
  src/level1/rocsparse_sctr.cpp
  src/level1/rocsparse_axpby.cpp
  src/level1/rocsparse_gather.cpp
  src/level1/rocsparse_scatter.cpp
  src/level1/rocsparse_rot.cpp
  src/level1/rocsparse_spvv.cpp

# Level2
  src/level2/rocsparse_bsrmv_ex.cpp
  src/level2/rocsparse_bsrmv.cpp
  src/level2/rocsparse_bsrxmv.cpp
  src/level2/rocsparse_bsrxmv_spzl_2x2.cpp
  src/level2/rocsparse_bsrxmv_spzl_3x3.cpp
  src/level2/rocsparse_bsrxmv_spzl_4x4.cpp
  src/level2/rocsparse_bsrxmv_spzl_5x5.cpp
  src/level2/rocsparse_bsrxmv_spzl_8x8.cpp
  src/level2/rocsparse_bsrxmv_spzl_16x16.cpp
  src/level2/rocsparse_bsrxmv_spzl_17_32.cpp
  src/level2/rocsparse_bsrxmv_spzl_general.cpp
  src/level2/rocsparse_bsrsv.cpp
  src/level2/rocsparse_bsrsv_analysis.cpp
  src/level2/rocsparse_bsrsv_buffer_size.cpp
  src/level2/rocsparse_bsrsv_solve.cpp
  src/level2/rocsparse_coomv.cpp
  src/level2/rocsparse_coomv_aos.cpp
  src/level2/rocsparse_csrmv.cpp
  src/level2/rocsparse_cscmv.cpp
  src/level2/rocsparse_csrsv.cpp
  src/level2/rocsparse_csrsv_analysis.cpp
  src/level2/rocsparse_csrsv_buffer_size.cpp
  src/level2/rocsparse_csrsv_solve.cpp
  src/level2/rocsparse_csritsv.cpp
  src/level2/rocsparse_csritsv_buffer_size.cpp
  src/level2/rocsparse_csritsv_analysis.cpp
  src/level2/rocsparse_csritsv_solve.cpp
  src/level2/rocsparse_coosv.cpp
  src/level2/rocsparse_ellmv.cpp
  src/level2/rocsparse_hybmv.cpp
  src/level2/rocsparse_spmv.cpp
  src/level2/rocsparse_spmv_ex.cpp
  src/level2/rocsparse_spsv.cpp
  src/level2/rocsparse_spitsv.cpp
  src/level2/rocsparse_gebsrmv.cpp
  src/level2/rocsparse_gebsrmv_template_row_block_dim_1.cpp
  src/level2/rocsparse_gebsrmv_template_row_block_dim_2.cpp
  src/level2/rocsparse_gebsrmv_template_row_block_dim_3.cpp
  src/level2/rocsparse_gebsrmv_template_row_block_dim_4.cpp
  src/level2/rocsparse_gebsrmv_template_row_block_dim_5_8.cpp
  src/level2/rocsparse_gebsrmv_template_row_block_dim_9_12.cpp
  src/level2/rocsparse_gebsrmv_template_row_block_dim_13_16.cpp
  src/level2/rocsparse_gebsrmv_template_row_block_dim_17_inf.cpp
  src/level2/rocsparse_gemvi.cpp

# Level3
  src/level3/rocsparse_gebsrmm_template_small.cpp
  src/level3/rocsparse_gebsrmm_template_large_ext.cpp
  src/level3/rocsparse_gebsrmm_template_general.cpp
  src/level3/rocsparse_gebsrmm.cpp
  src/level3/rocsparse_bsrmm_template_small.cpp
  src/level3/rocsparse_bsrmm_template_large_ext.cpp
  src/level3/rocsparse_bsrmm_template_general.cpp
  src/level3/rocsparse_bsrmm.cpp
  src/level3/rocsparse_bellmm.cpp
  src/level3/rocsparse_bellmm_template_general.cpp
  src/level3/rocsparse_csrmm_template_general.cpp
  src/level3/rocsparse_csrmm_template_row_split.cpp
  src/level3/rocsparse_csrmm_template_merge.cpp
  src/level3/rocsparse_csrmm.cpp
  src/level3/rocsparse_cscmm.cpp
  src/level3/rocsparse_coomm.cpp
  src/level3/rocsparse_coomm_template_atomic.cpp
  src/level3/rocsparse_coomm_template_segmented.cpp
  src/level3/rocsparse_coomm_template_segmented_atomic.cpp
  src/level3/rocsparse_spmm.cpp
  src/level3/rocsparse_csrsm.cpp
  src/level3/rocsparse_coosm.cpp
  src/level3/rocsparse_bsrsm.cpp
  src/level3/rocsparse_bsrsm_buffer_size.cpp
  src/level3/rocsparse_bsrsm_analysis.cpp
  src/level3/rocsparse_bsrsm_solve.cpp
  src/level3/rocsparse_bsrsm_template_large.cpp
  src/level3/rocsparse_gemmi.cpp
  src/level3/rocsparse_sddmm.cpp
  src/level3/rocsparse_sddmm_coo.cpp
  src/level3/rocsparse_sddmm_coo_aos.cpp
  src/level3/rocsparse_sddmm_csr.cpp
  src/level3/rocsparse_sddmm_csc.cpp
  src/level3/rocsparse_sddmm_ell.cpp
  src/level3/rocsparse_spsm.cpp

# Extra
  src/extra/rocsparse_bsrgeam.cpp
  src/extra/rocsparse_bsrgemm_buffer_size.cpp
  src/extra/rocsparse_bsrgemm_nnz.cpp
  src/extra/rocsparse_bsrgemm.cpp
  src/extra/rocsparse_csrgeam.cpp
  src/extra/rocsparse_csrgemm.cpp
  src/extra/rocsparse_csrgemm_symbolic.cpp
  src/extra/rocsparse_csrgemm_numeric.cpp
  src/extra/rocsparse_csrgemm_nnz.cpp
  src/extra/rocsparse_spgemm.cpp


# Preconditioner
  src/precond/rocsparse_bsric0.cpp
  src/precond/rocsparse_bsrilu0.cpp
  src/precond/rocsparse_csric0.cpp
  src/precond/rocsparse_csrilu0.cpp
  src/precond/rocsparse_gtsv.cpp
  src/precond/rocsparse_gtsv_no_pivot.cpp
  src/precond/rocsparse_gtsv_no_pivot_strided_batch.cpp
  src/precond/rocsparse_gtsv_interleaved_batch.cpp
  src/precond/rocsparse_gpsv_interleaved_batch.cpp
  src/precond/itilu0/common.cpp
  src/precond/itilu0/rocsparse_csritilu0x_buffer_size.cpp
  src/precond/itilu0/rocsparse_csritilu0x_preprocess.cpp
  src/precond/itilu0/rocsparse_csritilu0x_compute.cpp
  src/precond/itilu0/rocsparse_csritilu0x_history.cpp
  src/precond/itilu0/rocsparse_csritilu0x_sync_fusion.cpp
  src/precond/itilu0/rocsparse_csritilu0x_sync.cpp
  src/precond/itilu0/rocsparse_csritilu0x_async.cpp
  src/precond/itilu0/rocsparse_csritilu0_buffer_size.cpp
  src/precond/itilu0/rocsparse_csritilu0_preprocess.cpp
  src/precond/itilu0/rocsparse_csritilu0_compute.cpp
  src/precond/itilu0/rocsparse_csritilu0_history.cpp
  src/precond/itilu0/rocsparse_csritilu0_async_inplace.cpp
  src/precond/itilu0/rocsparse_csritilu0_async_split.cpp
  src/precond/itilu0/rocsparse_csritilu0_sync_split.cpp
  src/precond/itilu0/rocsparse_csritilu0_sync_split_fusion.cpp

# Conversion
  src/conversion/rocsparse_nnz.cpp
  src/conversion/rocsparse_csxsldu_buffer_size.cpp
  src/conversion/rocsparse_csxsldu_preprocess.cpp
  src/conversion/rocsparse_csxsldu_compute.cpp
  src/conversion/rocsparse_dense2csr.cpp
  src/conversion/rocsparse_dense2coo.cpp
  src/conversion/rocsparse_prune_dense2csr.cpp
  src/conversion/rocsparse_prune_dense2csr_by_percentage.cpp
  src/conversion/rocsparse_dense2csc.cpp
  src/conversion/rocsparse_csr2dense.cpp
  src/conversion/rocsparse_csc2dense.cpp
  src/conversion/rocsparse_coo2dense.cpp
  src/conversion/rocsparse_nnz_compress.cpp
  src/conversion/rocsparse_csr2coo.cpp
  src/conversion/rocsparse_csr2csc.cpp
  src/conversion/rocsparse_gebsr2gebsc.cpp
  src/conversion/rocsparse_csr2bsr.cpp
  src/conversion/rocsparse_csr2gebsr.cpp
  src/conversion/rocsparse_csr2ell.cpp
  src/conversion/rocsparse_csr2hyb.cpp
  src/conversion/rocsparse_csr2csr_compress.cpp
  src/conversion/rocsparse_prune_csr2csr.cpp
  src/conversion/rocsparse_prune_csr2csr_by_percentage.cpp
  src/conversion/rocsparse_coo2csr.cpp
  src/conversion/rocsparse_ell2csr.cpp
  src/conversion/rocsparse_hyb2csr.cpp
  src/conversion/rocsparse_bsr2csr.cpp
  src/conversion/rocsparse_gebsr2csr.cpp
  src/conversion/rocsparse_gebsr2gebsr.cpp
  src/conversion/rocsparse_identity.cpp
  src/conversion/rocsparse_csrsort.cpp
  src/conversion/rocsparse_cscsort.cpp
  src/conversion/rocsparse_coosort.cpp
  src/conversion/rocsparse_sparse_to_dense.cpp
  src/conversion/rocsparse_dense_to_sparse.cpp
  src/conversion/rocsparse_bsrpad_value.cpp

# Reordering
  src/reordering/rocsparse_csrcolor.cpp

# Util
  src/util/rocsparse_check_matrix_csr.cpp
  src/util/rocsparse_check_matrix_csc.cpp
  src/util/rocsparse_check_matrix_gebsr.cpp
  src/util/rocsparse_check_matrix_gebsc.cpp
  src/util/rocsparse_check_matrix_coo.cpp
  src/util/rocsparse_check_matrix_ell.cpp
  src/util/rocsparse_check_matrix_hyb.cpp
)

=== debian/changelog ===
rocsparse (5.7.1-6build1) resolute; urgency=medium

  * No change rebuild against newer rocm-hipamd

 -- Mario Limonciello <superm1@gmail.com>  Mon, 27 Oct 2025 13:00:43 -0500

rocsparse (5.7.1-6) unstable; urgency=medium

  * Substitute Sphinx book theme with rdt theme (Closes: #1087020)

 -- Kari Pahula <kaol@debian.org>  Mon, 25 Nov 2024 22:32:56 +0200

rocsparse (5.7.1-5) unstable; urgency=medium

  * d/rules: Drop --with=sphinxdoc I erroneously proposed.
    This is not needed thanks to the presence of dh-sequence-sphinxdoc, and
    actually introduces a FTBFS when building only arch:any packages.

 -- Christian Kastner <ckk@debian.org>  Fri, 17 May 2024 18:46:13 +0200

rocsparse (5.7.1-4) unstable; urgency=medium

  * Use python3-myst-nb to build rocsparse documents

 -- Xuanteng Huang <xuanteng.huang@outlook.com>  Wed, 15 May 2024 14:36:42 +0800

rocsparse (5.7.1-3) unstable; urgency=medium

  [ Christian Kastner ]
  * d/rules: Skip test building when Build-Profile=nocheck

  [ Cordell Bloor ]
  * Migrate to unstable
  * d/rules: Use rocprim arch conversion to ensure that rocsparse behaves the
    same on all RDNA 2 hardware

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 26 Mar 2024 11:03:36 -0600

rocsparse (5.7.1-3~exp2) experimental; urgency=medium

  * d/control: Add missing Breaks+Replaces for moved examples.
    They are now part of the -doc package. (Closes: #1065353)
  * autopkgtest: Export dmesg and other info as artifacts

 -- Christian Kastner <ckk@debian.org>  Sun, 03 Mar 2024 12:38:10 +0100

rocsparse (5.7.1-3~exp1) experimental; urgency=medium

  * Enable gfx1100, gfx1101, and gfx1102 architectures
  * Update Build-Depends for clang-17
  * Drop patchelf from Build-Depends
  * Move examples from dev package to doc package
  * Skip building test packages when nocheck option is enabled

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 29 Feb 2024 14:41:31 -0700

rocsparse (5.7.1-2) unstable; urgency=medium

  * Migrate to unstable
  * Update upstream URLs
  * Fix rocsparse_test.data install directory

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 28 Jan 2024 17:22:27 -0700

rocsparse (5.7.1-1) experimental; urgency=medium

  * New upstream version 5.7.1
  * Drop patch numbering

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 13 Dec 2023 16:36:43 -0700

rocsparse (5.5.1-2) unstable; urgency=medium

  * Add debian/clean (Closes: #1045919)
  * Filter cf-protection hardening from device code.
    Fixes a FTBFS with dpkg >= 1.22

 -- Christian Kastner <ckk@debian.org>  Thu, 14 Sep 2023 12:26:57 +0200

=== debian/control ===
Source: rocsparse
Section: devel
Homepage: https://github.com/ROCm/rocSPARSE
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rocm-team/rocsparse.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocsparse
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Maxime Chambonnet <maxzor@maxzor.eu>,
           Cordell Bloor <cgmb@slerp.xyz>,
           Étienne Mollier <emollier@debian.org>,
           Christian Kastner <ckk@debian.org>,
           Xuanteng Huang <xuanteng.huang@outlook.com>,
	   Kari Pahula <kaol@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               gfortran,
               hipcc (>= 5.6.1~),
               libamd-comgr-dev (>= 6.0~),
               libhsa-runtime-dev (>= 5.7.1~),
               rocm-cmake (>= 5.3.0),
               librocprim-dev (>= 5.5.1~),
               python3,
               python3-yaml,
               libgtest-dev <!nocheck>,
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
               doxygen <!nodoc>,
               python3-breathe <!nodoc>,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               python3-sphinx-design <!nodoc>,
               python3-sphinx-copybutton <!nodoc>,
               libjs-jquery <!nodoc>,
               libjs-mathjax <!nodoc>,
               libjs-sphinxdoc <!nodoc>,
               libjs-underscore <!nodoc>,
               python3-myst-nb <!nodoc>,
Rules-Requires-Root: no

Package: librocsparse0
Section: libs
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: ROCm library for sparse linear algebra - library
 rocSPARSE is a library that implements BLAS operations for sparse data
 structures. It is built on the AMD ROCm platform and optimized for
 discrete AMD GPUs.
 .
 rocSPARSE provides a C99 API containing sparse level 1, sparse level 2 and
 sparse level 3 BLAS functions, as well as general matrix multiplication
 between dense and sparse matricies (GEMMI), sparse preconditioner functions,
 sparse matrix format conversion functions, and sparse matrix reordering
 functions.
 .
 It supports a variety of sparse matrix formats, including coordinate list
 in either array of structure form (COO) or structure of array form (COO SOA),
 compressed sparse row (CSR) or column (CSC), block compressed sparse row
 (BSR), general block compressed sparse row (GEBSR), and the ELLPACK-ITPACK
 format (ELL).
 .
 This package provides the AMD ROCm rocSPARSE library.

Package: librocsparse-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocsparse0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Recommends: libamdhip64-dev
Suggests: librocsparse-doc
Description: ROCm library for sparse linear algebra - headers
 rocSPARSE is a library that implements BLAS operations for sparse data
 structures. It is built on the AMD ROCm platform and optimized for
 discrete AMD GPUs.
 .
 rocSPARSE provides a C99 API containing sparse level 1, sparse level 2 and
 sparse level 3 BLAS functions, as well as general matrix multiplication
 between dense and sparse matricies (GEMMI), sparse preconditioner functions,
 sparse matrix format conversion functions, and sparse matrix reordering
 functions.
 .
 It supports a variety of sparse matrix formats, including coordinate list
 in either array of structure form (COO) or structure of array form (COO SOA),
 compressed sparse row (CSR) or column (CSC), block compressed sparse row
 (BSR), general block compressed sparse row (GEBSR), and the ELLPACK-ITPACK
 format (ELL).
 .
 This package provides the AMD ROCm rocSPARSE development headers.

Package: librocsparse0-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Build-Profiles: <!nocheck>
Depends: librocsparse0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
         librocsparse0-tests-data
Description: ROCm library for sparse linear algebra - tests
 rocSPARSE is a library that implements BLAS operations for sparse data
 structures. It is built on the AMD ROCm platform and optimized for
 discrete AMD GPUs.
 .
 rocSPARSE provides a C99 API containing sparse level 1, sparse level 2 and
 sparse level 3 BLAS functions, as well as general matrix multiplication
 between dense and sparse matricies (GEMMI), sparse preconditioner functions,
 sparse matrix format conversion functions, and sparse matrix reordering
 functions.
 .
 It supports a variety of sparse matrix formats, including coordinate list
 in either array of structure form (COO) or structure of array form (COO SOA),
 compressed sparse row (CSR) or column (CSC), block compressed sparse row
 (BSR), general block compressed sparse row (GEBSR), and the ELLPACK-ITPACK
 format (ELL).
 .
 This package provides the AMD ROCm rocSPARSE test binaries used for verifying
 that the library is functioning correctly. These binaries are only used to
 check whether rocSPARSE works correctly on a given GPU, so generally speaking,
 users probably don't need this package.

Package: librocsparse0-tests-data
Section: libdevel
Architecture: all
Build-Profiles: <!nocheck>
Depends: ${misc:Depends},
Description: ROCm library for sparse linear algebra - test data
 rocSPARSE is a library that implements BLAS operations for sparse data
 structures. It is built on the AMD ROCm platform and optimized for
 discrete AMD GPUs.
 .
 rocSPARSE provides a C99 API containing sparse level 1, sparse level 2 and
 sparse level 3 BLAS functions, as well as general matrix multiplication
 between dense and sparse matricies (GEMMI), sparse preconditioner functions,
 sparse matrix format conversion functions, and sparse matrix reordering
 functions.
 .
 It supports a variety of sparse matrix formats, including coordinate list
 in either array of structure form (COO) or structure of array form (COO SOA),
 compressed sparse row (CSR) or column (CSC), block compressed sparse row
 (BSR), general block compressed sparse row (GEBSR), and the ELLPACK-ITPACK
 format (ELL).
 .
 This package provides the data files required by the AMD ROCm rocSPARSE tests.
 The tests are only used to check whether rocSPARSE works correctly on a given
 GPU, so generally speaking, users probably don't need this package.

Package: librocsparse-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Replaces: librocsparse-dev (<< 5.7.1-3~)
Breaks: librocsparse-dev (<< 5.7.1-3~)
Description: ROCm library for sparse linear algebra - documentation
 rocSPARSE is a library that implements BLAS operations for sparse data
 structures. It is built on the AMD ROCm platform and optimized for
 discrete AMD GPUs.
 .
 rocSPARSE provides a C99 API containing sparse level 1, sparse level 2 and
 sparse level 3 BLAS functions, as well as general matrix multiplication
 between dense and sparse matricies (GEMMI), sparse preconditioner functions,
 sparse matrix format conversion functions, and sparse matrix reordering
 functions.
 .
 It supports a variety of sparse matrix formats, including coordinate list
 in either array of structure form (COO) or structure of array form (COO SOA),
 compressed sparse row (CSR) or column (CSC), block compressed sparse row
 (BSR), general block compressed sparse row (GEBSR), and the ELLPACK-ITPACK
 format (ELL).
 .
 This package provides the AMD ROCm rocSPARSE documentation.

=== debian/rules ===
#!/usr/bin/make -f
export CXX=hipcc
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-fortify optimize=-lto
export DEB_CXXFLAGS_MAINT_PREPEND = -gz -DROCPRIM_USE_ARCH_CONVERSION
export VERBOSE=1

# filter incompatible options from affecting device code
CXXFLAGS := $(subst -fstack-protector-strong,-Xarch_host -fstack-protector-strong,$(CXXFLAGS))
CXXFLAGS := $(subst -fcf-protection,-Xarch_host -fcf-protection,$(CXXFLAGS))

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_SKIP_RPATH=ON \
	-DAMDGPU_TARGETS="gfx803;gfx900;gfx906;gfx908;gfx90a;gfx1010;gfx1030;gfx1100;gfx1101;gfx1102" \
	-DROCM_SYMLINK_LIBS=OFF \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF \
	-DWITH_TEST_MATRICIES=OFF

ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
CMAKE_FLAGS += \
	-DBUILD_CLIENTS_TESTS=ON
endif

%:
	dh $@ -Scmake

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e \
	; if [ -r /dev/kfd ] \
	; then LD_LIBRARY_PATH=obj-$(DEB_HOST_MULTIARCH)/library \
	    obj-$(DEB_HOST_MULTIARCH)/clients/staging/rocsparse-test \
	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
	;      echo "W: tests skipped." \
	; fi
endif

execute_before_dh_install-arch:
	:

override_dh_auto_configure-indep:
	:

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	cd docs; doxygen
	http_proxy='127.0.0.1:9' \
	https_proxy='127.0.0.1:9' \
	sphinx-build -v -b html docs/source html
	find $(CURDIR) -type d -name "__pycache__" -exec rm -rf {} +
endif
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	python3 clients/common/rocsparse_gentest.py -I clients/include clients/tests/rocsparse_test.yaml -o rocsparse_test.data
endif

override_dh_auto_test-indep:
	:

override_dh_auto_install-indep:
	:

override_dh_dwz:
	:
